#pragma once

#include "ros_bridge/rapidjson/include/rapidjson/document.h"

#include <memory>
#include <tuple>

#include "boost/lockfree/queue.hpp"
#include "ros_bridge/include/

namespace ROSBridge {
namespace lf = ::boost::lockfree;
class Communicator
{
    typedef std::unique_ptr<rapidjson::Document> UniqueJsonPtr;
    typedef std::tuple<UniqueJsonPtr, std::string> MsgTopicHashPair;
public:
  explicit Communicator() {}

    void send(UniqueJsonPtr &msg);
    void start();
    void stop();
    virtual UniqueJsonPtr receive() = 0;

private:
    lf::queue<MsgTopicPair> _transmittBuffer;
    lf::queue<MsgTopicPair> _receiveBuffer;
};
}
